<?php

// year:         2008
// author:       Vallati Carlo <carlo.vallati@iet.unipi.it>
//		 Andreozzi Matteo <matteo.andreozzi@iet.unipi.it>
// affiliation:  Dipartimento di ingegneria dell'informazione
//               Universita di Pisa - Italy

//       This script generate graphs from simulated scenarios.
//	 The xml file that describe the simulation must be placed 
//	 into the directory with .dat files and must be renamed as 
//	 info.xml. 
//	 This script seeks for simuation scenarios into a dir
//	 named "simulations" and in its subdirectory.

require_once('utils.inc');
?>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta http-equiv="expires" content="0">
<meta http-equiv="cache-control" content="no-store">
<meta http-equiv="pragma" CONTENT="no-cache">
<title>ANSWER FRAMEWORK - THE DRAWER</title>
<meta name="keywords" content="" />
<meta name="description" content="" />
<link href="style.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
<div id="wrapper">
	<div id="header">
		<div id="logo">
			<h1><a href="http://cng1.iet.unipi.it/wiki/index.php/ANSWER">Answer</a></h1>
			<h2>by <a href="http://cng1.iet.unipi.it/wiki/index.php/Main_Page">Computer Networking Group</a> </a></h2>
		</div>
		<!-- end #logo -->
		<div id="menu">
			<ul>
				<li class="first" ><a href="http://cng1.iet.unipi.it/wiki/index.php/Main_Page">CNG Website</a></li>
				<li><a href="http://cng1.iet.unipi.it/wiki/index.php/ANSWER">About</a></li>
				<li><a href="mailto:matteo.andreozzi@iet.unipi.it;carlo.vallati@iet.unipi.it">Contact Us</a></li>
			</ul>
		</div>
		<!-- end #menu -->
	</div>
	<!-- end #header -->
	<div id="page">
		<div id="bgtop">
			<div id="bgbottom">
				<div id="content">
					<div class="post">
						<div class="title">
							<h2><a href="#">Choose parameters</a></h2>
						</div>
						<div class="entry"><p>


<?
if (!isset($_POST['mode']) || $_POST['mode'] == 0  )
{
	exec("rm -rf ./tmp/".session_id());
	list_simulations("./simulations");

}

//second invocation, we list all subdirectory
elseif($_POST['mode']=='1'){
	list_simulations($_POST['scenario']);
}

// second invocation, we list all files in selected subdir
elseif($_POST['mode']=='2'){
	list_simulations($_POST['scenario']);
// third invocation, ask for parameters
} elseif($_POST['mode']=='3'){
	// Load xml configuration
	$key = simplexml_load_file(dirname($_POST['scenario']).'/info.xml');
	foreach ( $key->multicell->param as $par){
		check_alias($par);
	}
	
	echo "<form method='POST' action='".basename($_SERVER['SCRIPT_NAME'])."'>\n";
	
	// Generate the options grid 
	$ind=0;
	$maxRowItems=8;
	foreach ( $key->multicell->param as $par){
		$base_params[$ind]=$par->name;
		list_params($par,"father","");
		$ind++;
	}

	if(is_dst(basename($_POST['scenario']))==false){
		$indexes=shell_exec("cat ".$_POST['scenario']." | ./tools/enum.pl");
	}
	else{
		$indexes=shell_exec("cat ".$_POST['scenario']." | ./tools/enum.pl -pos 3");
		$_POST['x']="dst";
	}	

	$indexes=explode("\n", $indexes);
	$arrayname=array();
	// Add indexes to the option grid
	echo "<div><b>Indexes</b>\n";
	$ind=0;
	foreach ($indexes as $i){
		if($i != ""){
			$i=trim($i);
			echo "<input type='checkbox' name='index_".$i."' value='".$i."' id='genindex_".$i."'>".$i."\n";
			array_push($arrayname,"index_".$i);
			$ind++;
			if (!($ind%$maxRowItems))
			{
				echo "</div>\n<div>";
			}
		}
	}
	
	if (count($arrayname)>1){
	$st="( ";
	for ($i=0; $i<count($arrayname);$i++){
	if (($i+1)==count($arrayname))
		$st.="elements[i].name == '".$arrayname[$i]."')";
	else $st.="elements[i].name == '".$arrayname[$i]."' || ";
	}
	echo "<input type='checkbox' id='$arrayname[0]'  value='Select all' onclick=\" for (var i=0; i < elements.length; i++) { if (elements[i].type == 'checkbox' && $st ){ if (document.getElementById('$arrayname[0]').checked==true) elements[i].checked = true; else elements[i].checked = false;}} \">Select all\n";
	}
 	 else if (count($arrayname)==1){ 
			echo "<script type=\"text/javascript\">";
			echo "document.getElementById('gen".$arrayname[0]."').checked=true;";
			echo "</script>";
		}

	echo "</div>";

	echo "<div>x-axys:\n";
	$base_params[$ind]="index";
	
	if(is_dst(basename($_POST['scenario']))==false)
		drop_menu($base_params,"x");
	echo "</div>";
	echo "y-sorted : <input type='checkbox' name='ysort'>\n";
	echo "<input type='hidden' name='scenario' value='".$_POST['scenario']."'>\n";
	echo "<input type='hidden' name='scenario_name' value='".$key->name."'>\n";
	echo "<input type='hidden' name='mode' value='".($_POST['mode']+1)."'>\n";
	echo "<div><input type='submit' value='Next'></div>\n";
	echo "</form>\n</p>\n</div>\n";
	
// Fourth invocation, choice label name
}  elseif($_POST['mode']=='4'){
	$key = simplexml_load_file(dirname($_POST['scenario']).'/info.xml');
	foreach ( $key->multicell->param as $par){
		check_alias($par);
	}
	
	$ris= array();
	foreach( $key->multicell->param as $par){
		array_push($ris,sim($par));
	}
	
	if(is_dst(basename($_POST['scenario']))==false){
		$indexes=shell_exec("cat ".$_POST['scenario']." | ./tools/enum.pl ");
	}
	else{
		$indexes=shell_exec("cat ".$_POST['scenario']." | ./tools/enum.pl -pos 3");
		$_POST['x']="dst";
	}
	$indexes=explode("\n", $indexes);
	if($_POST['x']!="index"){
		$index=array();
		foreach( $indexes as $i){
			$i=trim($i);
			$str="index_".$i;
			if( isset($_POST["$str"]) ){
				array_push($index,"index_".$i."_");
			}
		}
		array_push($ris,$index);
		
	}
	else{
		array_push($ris,array("index_X_"));
	}
	$ris=permute($ris);
	$final=array();
	foreach($ris as $vect){
		$cmd="";
		foreach($vect as $string){
			$cmd.=$string;
		}
		array_push($final,$cmd);
	}

	$mypid=session_id();
	$mypid="tmp/".$mypid;
	exec("rm -rf $mypid");
	exec("mkdir ".$mypid);

	echo "<form method='POST' action='".basename($_SERVER[ 'SCRIPT_NAME'])."'>";
	echo "<p><b>Plot labels</b>";
	echo "<table border=0>";

	$scenarios="";
	foreach($final as $item){
		$ext=name2extr($item);
		$cmd="cat ".$_POST['scenario']." | ./tools/extract ";
		$cmd.=$ext;
		if ( isset ($_POST['ysort']) ) {
			$cmd .= "| ./tools/ysort.sh ";
		}
		$cmd.=" > ".$mypid."/".$item.".tmp";
		if($_POST['x']=="dst"){
			$cmd.=" X";
		}
		exec($cmd);

		if ( filesize( $mypid."/".$item.".tmp") == 0 ) {
			unlink($mypid."/".$item.".tmp");
			continue;
         }
		
		$input_value = $item;
		$input_value = ereg_replace ("_index_X_", "", $input_value);
		$input_value = ereg_replace ("_", "\_", $input_value);
		echo "<tr><td>&nbsp;<td><input size='80' type='text' name='$item.tmp' value='$input_value'>";
	}
	echo "</table>\n";
	
	$scenario_split = split ('/', $_POST['scenario']);
	$file_name = $scenario_split[count($scenario_split)-1];
	$file_name = ereg_replace ("\.dat", "", $file_name);

	$xlabel = ereg_replace ("_", "\_", $_POST['x']);
	$ylabel = ereg_replace ("_", "\_", $file_name);

	echo "<input type='hidden' name='basedir' value='".$mypid."'>\n";
	echo "<p><b>Plot options</b>";
	echo "<table border=0>";
	echo "<tr><td>x-axys label<td><input type='text' name='xlabel' value='$xlabel'><td>\n";
	echo "<tr><td>x-axys range<td><input type='text' name='xrange' value='[:]'><td>(e.g., [1:5], [:100])\n";
	echo "<tr><td>x-axys log scale<td><input type='checkbox' name='xlog' value='off'><td>\n";
	echo "<tr><td>y-axys label<td><input type='text' name='ylabel' value='$ylabel'><td>\n";
   	echo "<tr><td>y-axys range<td><input type='text' name='yrange' value='[:]'><td>(e.g., [1:5], [:100])\n";
	echo "<tr><td>y-axys log scale<td><input type='checkbox' name='ylog' value='off'><td>\n";
	echo "<tr><td>title<td><input type='text' name='title' value='".$_POST['scenario_name']."'>\n";
	echo "<tr><td>key position<td><input type='text' name='key' value='Left bottom right'><td>(combine: left, right, top, bottom, Left, Right)\n";
	echo "<tr><td>font<td><input type='text' name='font' value='Arial'><td>(e.g., Arial, Times-New-Roman)\n";
	echo "<tr><td>font size<td><input type='text' name='font_size' value='14'><td>points\n";
	echo "</table>\n";

	echo "<p><b>Output</b>";
	echo "<table border=0>";
	echo "<tr><td>print dat<td><input type='checkbox' name='print_dat' value='off'><td>\n";
	echo "<tr><td>error bars<td><input type='checkbox' name='print_yerr' checked><td>\n";
	echo "</table>\n";
	echo "<input type='hidden' name='mode' value='".($_POST['mode']+1)."'>";
	echo "<p><input type='submit' value='Plot'>\n";
	echo "<input type='hidden' name='metrics_dir' value='".dirname($_POST['scenario'])."'>";
	echo "</$file>\n";
} elseif($_POST['mode']=='5'){

	$dm = dir ($_POST['metrics_dir']);

	chdir($_POST['basedir']);

	$scenarios="";
	$labels="";

	$d=dir("./");
	while(false!==($entry=$d->read())){
		if ( preg_match("/\.tmp/", $entry ) ) {
			$scenarios.=$entry." ";
			// Create labels
			$ent=strtr($entry,".","_");
			if(strlen($_POST[$ent])!=0){
				$labels.="'".$_POST[$ent]."' ";
			}
			else{
				$ent=strtr($entry,"_"," ");
				$labels.="'".$ent."' ";
			}
			// Sort file
			exec("sort -g $entry > tmp");
			exec("cat tmp > $entry");
		}
	}
	
	// Remove old graph
	exec("rm graph.png");
	exec("rm graph.eps");
	exec("rm graph.csv");
	exec("rm graph.gnuplot");
	exec("rm graph.tar");

	$xlog = '';
	$ylog = '';
	if ( isset ($_POST['xlog']) ) { $xlog = '-xlog'; }
	if ( isset ($_POST['ylog']) ) { $xlog = '-ylog'; }
		
	// Print graph
	$print_cmd="../tools/print.pl -with-labels $scenarios $labels ".
						"-output graph.eps ".
						"-script graph.gnuplot ".
						"-title '".$_POST['title']."' ".
						"-font-size 12 ".
						"-point-size 1 ".
						(( ! isset ($_POST['print_yerr']) ) ? "" : "-with-yerrorbars ").
						"-type eps ".
						"-font '".$_POST['font']."' ".
						"-font-size '".$_POST['font_size']."' ".
						"-yrange ".$_POST['yrange']." ".
						"-xrange ".$_POST['xrange']." ".
						"$xlog $ylog ".
						"-xlabel '".$_POST['xlabel']."' ".
						"-ylabel '".$_POST['ylabel']."' ".
						"-key '".$_POST['key']."'";

	// Print graph
	exec($print_cmd);

	// Convert eps to png
	exec("convert -rotate 90 graph.eps graph.png");

	// Create the csv file
	exec("../../tools/csv.sh *.tmp");

	// Create the package
	exec("tar cf graph.tar *.tmp graph.gnuplot");

	//exec("cp graph.png graph.eps ../");
		
	//exec("rm graph.png");
	//exec("rm graph.eps");

	echo "<p><a href='".$_POST['basedir']."/graph.eps'>EPS</a>".
		  ",<a href='".$_POST['basedir']."/graph.csv'>CSV</a>".
		  ",<a href='".$_POST['basedir']."/graph.png'>PNG</a>".
		  ",<a href='".$_POST['basedir']."/graph.tar'>TAR</a>".
		  "</p>";
	echo "<p><img width='95%' src='".$_POST['basedir']."/graph.png'></p>";

	echo "<BR><BR><BR>";

	if(isset($_POST['print_dat'])){
		
		$d=dir("./");
		while(false!==($entry=$d->read())){
			if($entry!='.' && $entry!='..' ){
				if(stripos($entry,"tmp")!=FALSE){
					echo "<BR>";
					$dat=file_get_contents($entry);
					echo $entry;
					echo "<BR>";
					$dat=str_replace("\n","\n<BR>",$dat);
					echo $dat;
					echo "<BR>";
				}
			}
		}
		
	}
		
 	$_POST['mode']=0;

	

} else die ('</br><h1>abnormal Mode detected. Check code</h1></br>');

?>
						</p>
						</div>
						</div>
					</div>
					
				<!-- end #content -->
				<div id="sidebar">
					<!--<ul>
						<li>
							<h2><a href='#'>Next Step</a></h2>
							
						</li>
					</ul>
					<ul>
						<li>
							<h2><a href='#'>Previous Step</a></h2>
							
						</li>
					</ul>-->
				</div>
				<!-- end #sidebar -->
				<div style="clear: both;">&nbsp;</div>
			</div>
		</div>
	</div>
	<!-- end #page -->
	<div id="footer">
		
	</div>
	<!-- end #footer -->
</div>
<!-- end #wrapper -->
</body>
</html>
