#!/usr/bin/perl

use Getopt::Long;

GetOptions (
	"col=s"           => \$col,
	"factor=s"        => \$factor,
	"help"            => \$help
);

$tmpfile = "/tmp/scale.pl.$$";

if ( $#ARGV < 0 || $help ) {
	print "usage: scale.pl files...\n".
		"\n".
		"      [-help]\n".
		"      [-col c]\n".
		"      [-factor f]\n".
		"\n";
	exit -1;
}

$col = 1 if ! $col;
$factor = 100.0 if ! $factor;
		

for $i ( 0 .. $#ARGV ) {
	open FILEIN, "<", $ARGV[$i] or die "could not open '$ARGV[$i]': $!";
	open FILEOUT, ">", $tmpfile or die "could not open '$tmpfile': $!";
	
	while ( <FILEIN> ) {
		chomp;
		my @line = split;
		$line[$col-1] *= $factor;
		print FILEOUT "@line\n";
	}

	close FILEOUT;
	close FILEIN;

	system "/bin/mv $tmpfile $ARGV[$i]";
}
